/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Messagebox;

import com.rjconsultores.ventaboletos.entidad.EmpresaImposto;
import com.rjconsultores.ventaboletos.service.EmpresaImpostoService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;


/**
 * 
 * @author Rafius
 */
@Controller("editarEmpresaImpostoController")
@Scope("prototype")
public class EditarEmpresaImpostoController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger(EditarEmpresaImpostoController.class);


	private EmpresaImposto empresaImposto;

	@Autowired
	private EmpresaImpostoService empresaImpostoService;
	
	private MyListbox empresaImpostoList;

	/**
	 * @return the empresaImposto
	 */
	public EmpresaImposto getEmpresaImposto() {
		return empresaImposto;
	}

	/**
	 * @param empresaImposto
	 *            the empresaImposto to set
	 */
	public void setEmpresaImposto(EmpresaImposto empresaImposto) {
		this.empresaImposto = empresaImposto;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		EmpresaImposto empresaImposto = (EmpresaImposto) Executions.getCurrent().getArg().get("empresaImposto");
		this.empresaImpostoList = (MyListbox) Executions.getCurrent().getArg().get("empresaImpostoList");
		
		this.empresaImposto = empresaImpostoService.obtenerID(empresaImposto.getEmpresaImpostoId());
		

		super.doAfterCompose(comp);

	}

	public void onClick$btnEmpresaImpostoSalvar(Event ev) throws InterruptedException {
		try {

			empresaImpostoService.actualizacion(this.empresaImposto);
			Messagebox.show(
					Labels.getLabel("editarEmpresaImpostoController.window.sucessoSalvar"),
					Labels.getLabel("editarEmpresaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

			closeWindow();

		} catch (Exception ex) {

			log.error("editarEmpresaController: " + ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarEmpresaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnEmpresaImpostoApagar(Event ev) { 
		try {
			int resp = Messagebox.show(
					"Deseja apagar este registro?",
					Labels.getLabel("editarEmpresaController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {

				empresaImpostoService.borrar(this.empresaImposto);
				
				this.empresaImpostoList.removeItem(this.empresaImposto);

				Messagebox.show( 
						Labels.getLabel("editarEmpresaImpostoController.window.sucessoApagar"),
						Labels.getLabel("editarEmpresaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

}
